module day01

using Lazy

function task1(file::IOStream)

    @as x eachline(file) begin
        parse.(Int, x)
        map(<, x, x[2:end])
        sum(x)
    end

end

function task2(file::IOStream)

    @as x eachline(file) begin
        parse.(Int, x)
        map((y...) -> sum(y), x, x[2:end], x[3:end])
        map(<, x, x[2:end])
        sum(x)
    end

end

end # module

println("Day 01 – Task 1 – Case 0")
open(day01.task1, "day01\\data\\case00.txt") |> println

println("Day 01 – Task 1 – Case 1")
open(day01.task1, "day01\\data\\case01.txt") |> println

println("Day 01 – Task 2 – Case 0")
open(day01.task2, "day01\\data\\case00.txt") |> println

println("Day 01 – Task 2 – Case 1")
open(day01.task2, "day01\\data\\case01.txt") |> println