##

function task0(file)
    fish = readline(file) |>
           x -> split(x, ",") .|>
                x -> parse(Int, x)

    for generation = 1:80
        fish = [🐟 == 0 ? [6, 8] : [🐟 - 1] for 🐟 ∈ fish] |> x -> vcat(x...)
    end

    length(fish)
end

##

println("Day 06 – Task 1 – Case 0")
open(task0, "day06\\data\\case00.txt") |> display
@assert open(task0, "day06\\data\\case00.txt") == 5934

println("Day 06 – Task 1 – Case 1")
open(task0, "day06\\data\\case01.txt") |> println
@assert open(task0, "day06\\data\\case01.txt") == 349549

##

function task1(file)
    fish = readline(file) |>
           x -> split(x, ",") .|>
                x -> parse(Int, x)

    🐠 = zeros(Int, 9)

    for 🐟 ∈ fish
        🐠[🐟+1] += 1
    end

    for generation = 1:256
        🐠 = [🐠[2:7]; 🐠[1] + 🐠[8]; 🐠[9]; 🐠[1]]
    end

    sum(🐠)
end

##

println("Day 06 – Task 2 – Case 0")
open(task1, "day06\\data\\case00.txt") |> display
@assert open(task1, "day06\\data\\case00.txt") == 26984457539

println("Day 06 – Task 2 – Case 1")
open(task1, "day06\\data\\case01.txt") |> println
@assert open(task1, "day06\\data\\case01.txt") == 1589590444365
