using Statistics

##

function task0(file)
    readline(file) |>
    x -> split(x, ",") .|>
         (x -> parse(Int, x)) |>
         (x -> convert(Int, sum(abs.(x .- median(x)))))
end

##

println("Day 07 – Task 1 – Case 0")
open(task0, "day07\\data\\case00.txt") |> display
@assert open(task0, "day07\\data\\case00.txt") == 37

println("Day 07 – Task 1 – Case 1")
open(task0, "day07\\data\\case01.txt") |> println
@assert open(task0, "day07\\data\\case01.txt") == 336701

##

function objective(x, a)
    let err = abs.(x .- a)
        sum((err .* (err .+ 1)) ./ 2)
    end
end

function task1(file)
    a = readline(file) |> x -> split(x, ",") .|> x -> parse(Int, x)

    # Might be massaged into a perfect estimate?
    x = convert(Int, round(mean(a)))

    while true
        if objective(x, a) > objective(x + 1, a)
            x += 1
        elseif objective(x, a) > objective(x - 1, a)
            x -= 1
        else
            return convert(Int, objective(x, a))
        end
    end
end

##

println("Day 07 – Task 2 – Case 0")
open(task1, "day07\\data\\case00.txt") |> display
@assert open(task1, "day07\\data\\case00.txt") == 168

println("Day 07 – Task 2 – Case 1")
open(task1, "day07\\data\\case01.txt") |> println
@assert open(task1, "day07\\data\\case01.txt") == 95167302