using Printf

day = 8

function verify(day, task, case, expresult)
    taskfun = getfield(Main, Symbol("task", task-1))
    filename = "day$(@sprintf "%02d" day)\\data\\case$(@sprintf "%02d" case).txt"

    println("Day $day – Task $task – Case $case")
    (result = open(taskfun, filename)) |> display
    @assert result == expresult
end

##

function task0(file)
    (eachline(file) .|>
     (x -> split(x, "|")[2]) .|>
     (x -> split(x, " ")) .|>
     (x -> sum(map(y -> length(y) ∈ [2, 3, 4, 7], x)))) |>
    sum
end

##

verify(8, 1, 0, 26)
verify(8, 1, 1, 247)

##

function task1(file)

    numbers = map(eachline(file)) do line
        mapping = split(split(line, " | ")[1], " ") .|> x -> Set(split(x, ""))
        number = split(split(line, " | ")[2], " ") .|> x -> Set(split(x, ""))

        local n0, n1, n2, n3, n4, n5, n6, n7, n8, n9

        m5 = Set(["a", "b", "c", "d", "e", "f", "g"])
        m6 = Set(["a", "b", "c", "d", "e", "f", "g"])

        for n in mapping
            if length(n) == 2
                n1 = n
            elseif length(n) == 3
                n7 = n
            elseif length(n) == 4
                n4 = n
            elseif length(n) == 5
                m5 = intersect(m5, n)
            elseif length(n) == 6
                m6 = intersect(m6, n)
            elseif length(n) == 7
                n8 = n
            end
        end

        a = setdiff(n7, n1)
        cde = setdiff(n8, m6)
        bcef = setdiff(n8, m5)
        ce = intersect(cde, bcef)
        bf = setdiff(bcef, ce)
        d = setdiff(cde, ce)
        c = intersect(ce, n1)
        e = setdiff(ce, c)
        f = intersect(bf, n1)
        b = setdiff(bf, f)
        g = setdiff(n8, union(a, b, c, d, e, f))

        n0 = union(a, b, c, e, f, g)
        n2 = union(a, c, d, e, g)
        n3 = union(a, c, d, f, g)
        n5 = union(a, b, d, f, g)
        n6 = union(a, b, d, e, f, g)
        n9 = union(a, b, c, d, f, g)

        lookup = [n0, n1, n2, n3, n4, n5, n6, n7, n8, n9]

        (indexin(number, lookup) .- 1)' * 10 .^ ((length(number)-1):-1:0)
    end

    sum(numbers)
end

##

verify(8, 2, 0, 61229)
verify(8, 2, 1, 933305)
